/*--------------------------------------------------------------------
 * $Id: ancillary.h,v 1.18 2005/12/21 15:42:02 bernhard Exp $
 * 
 * This file is part of libRadtran.
 * Copyright (c) 1997-2001 by Arve Kylling and Bernhard Mayer.
 * 
 * ######### Contact info: http://www.libradtran.org #########
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License   
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.        
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the   
 * GNU General Public License for more details.                    
 * 
 * You should have received a copy of the GNU General Public License          
 * along with this program; if not, write to the Free Software                
 * Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *--------------------------------------------------------------------*/

#ifndef __ancillary_h
#define __ancillary_h

#include <stdio.h>
#include "uvspec.h"

int setup_wlgrid (input_struct input, output_struct *output);

int arb_wvn( int n_old_x, float *old_x, float *old_y,  
	     int n_new_x, float *new_x, float *new_y, 
             int linear, int descend);

int arb_wvn_zero (int n_old_x, float *old_x, float *old_y,  
		  int n_new_x, float *new_x, float *new_y, 
		  int linear, int descend);

int arb_wvn2 (int n_old_x, float *old_x, float *old_y,  
	      int n_new_x_lower, int n_new_x_upper, float *new_x, float *new_y, int linear);

int interpolate_profile (float *x, float **y, int n,  
			 float *xnew, int nnew, int interpol_method, 
                         int quiet );

int interpolate_density (float *x, float **y, int n, 
                         float *xnew, int nnew, int interp_method, 
                         float *dens_air_old, float *dens_air, int quiet );
     
int interpolate_atmosphere (float *z, float **p, float **T, float **dens, int n,  
			    float *znew, int nnew, 
                            int interpol_method_press, int interpol_method_temper, int *interpol_method_gas, 
                            int quiet);


int set_transmittance_wl_grid(wl_inp_struct *wl_inp, wl_out_struct *wl_out);

int convolve(input_struct input, output_struct *output);
int spline_interpolate(input_struct input, output_struct *output);

int interpolate_transmittance (input_struct input, output_struct *output);
int multiply_extraterrestrial (input_struct input, output_struct *output);
int crs_rayleigh_nicolet(float* lambda, int n_lambda, float ***crs );
int crs_rayleigh_bodhaine(float* lambda, int n_lambda, float mixing_ratio_co2, 
			  float *depol, float ***crs );
int optical_properties (input_struct input, output_struct *output, int iv, int iq);
int integrate3D (input_struct input, output_struct *output);
int integrate1D (input_struct input, output_struct *output);
int heating1D (input_struct input, output_struct *output);
int sum1D (input_struct input, output_struct *output);
float log_average(float d1,float d2);
float linmix_average(float m1,float m2,float n1,float n2);

#endif



